<template>
  <template v-if="page.loading">
    <HourglassIcon v-if="page.showLoading = true"/>
  </template>

  <template v-else>
    <div class="restaurant-page">
      <NavBar />

      <HourglassIcon v-if="page.showHourglass" />

      <Notification />

      <!-- CONFIRMATION CONTENT -->
      <ModalWindow v-if="page.showConfirmation" @close="page.showConfirmation = false" :title="confirmation_window.title" :body="confirmation_window.body">
        <!-- Booking details-->
        <div id="confirmationInfo" class="card-body">
          <p class="card-text card-info">Restaurant: {{ this.data.restaurant.information.name }}</p>
          <p class="card-text card-info">Date: {{ this.date.picker }}</p>
          <p class="card-text card-info">Time: {{ this.time.picker }}</p>
          <p class="card-text card-info">Number of Guests: {{ this.pax.picker }}</p>
        </div>
        <!-- Confirmation User Details Form -->
        <div id="confirmationForm" class="mb-3">
          <label for="guest-name" class="form-label">Name:</label>
          <input v-model="person.name" id="guest-name" type="text" class="form-control" placeholder="Firstname Lastname" required>
          <label for="mobile" class="form-label">Mobile number:</label>
          <input v-model="person.mobile" id="mobile" type="tel" class="form-control" minlength="10" maxlength="10" placeholder="0412345678" required>
          <label for="notes" class="form-label">Additional information:</label>
          <textarea v-model="person.notes" id="notes" class="form-control" rows="3" placeholder="Please enter any additional information, such as special requests"></textarea>
        </div>
        <!-- Confirmation Submit Button -->
        <div v-if="page.showInvalid.submitBtn" id="invalidSubmit" class="invalid-entry">{{ invalid_note }}</div>
        <div id="submitContainer" class="row">
          <div>
            <button id="submitBookingBtn" class="btn btn-light" type="submit" @click="submit">Submit</button>
          </div>
        </div>
      </ModalWindow>
      <!-- END OF CONFIRMATION CONTENT -->

      <!-- SERVER RESPONSE DISPLAY WINDOW -->
      <ModalWindow v-if="page.showResponse" @close="page.showResponse = false"
                   :title="response_window.title"
                   :body="response_window.body"/>

      <div id="mainBody" class="container-fluid">
          <!-- MAIN HEADER CONTENT -->
          <MainHeader :main_text="String('Try the taste of ') + this.data.restaurant.information.name"
                      :sub_text="String('book now with DropBearTable')"/>

          <!-- MIDDLE ROW CONTENT -->
          <div id="middleRow" class="row">
            <!-- CAROUSEL IMAGES -->
            <Carousel :key="this.data.restaurant.website_parameter.img" :images="this.data.restaurant.website_parameter.img"/>
            <!-- END OF CAROUSEL IMAGES -->

            <div id="restaurantInfo" class="card">
              <!-- RESTAURANT TEXT INFO -->
              <div id="restaurantHeader" class="card-header">
                <h1 id="restaurantName">{{ this.data.restaurant.information.name }}</h1>
              </div>
              <div class="card-body">
                <h5 class="card-title">{{ this.data.restaurant.website_parameter.detail }}</h5>
                <p class="card-text">{{ this.data.restaurant.website_parameter.sub_detail }}</p>
                <!-- END OF RESTAURANT TEXT INFO -->

                <!-- SEARCH BAR -->
                <div id="searchPropertiesBar" class="input-group">
                  <!-- Calendar Start -->
                  <div class="input-group-prepend">
                    <label class="input-group-text" for="calendarInput">
                      <svg xmlns="http://www.w3.org/2000/svg" width="34" height="34" fill="currentColor" class="bi bi-calendar4-event" viewBox="0 0 16 16">
                        <path d="M3.5 0a.5.5 0 0 1 .5.5V1h8V.5a.5.5 0 0 1 1 0V1h1a2 2 0 0 1 2 2v11a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2V3a2 2 0 0 1 2-2h1V.5a.5.5 0 0 1 .5-.5zM2 2a1 1 0 0 0-1 1v1h14V3a1 1 0 0 0-1-1H2zm13 3H1v9a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V5z"/>
                        <path d="M11 7.5a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1z"/>
                      </svg>
                    </label>
                  </div>
                  <input v-model="date.picker" :min="date.default" :max="date.max" type="date" name="date" class="form-control" id="calendarInput">
                  <!-- Calendar End -->
                  <!-- Time Selection Start -->
                  <div class="input-group-prepend">
                    <label class="input-group-text" for="timeInput">
                      <svg xmlns="http://www.w3.org/2000/svg" width="34" height="34" fill="currentColor" class="bi bi-clock" viewBox="0 0 16 16">
                        <path d="M8 3.5a.5.5 0 0 0-1 0V9a.5.5 0 0 0 .252.434l3.5 2a.5.5 0 0 0 .496-.868L8 8.71V3.5z"/>
                        <path d="M8 16A8 8 0 1 0 8 0a8 8 0 0 0 0 16zm7-8A7 7 0 1 1 1 8a7 7 0 0 1 14 0z"/>
                      </svg>
                    </label>
                  </div>
                  <select v-model="time.picker" class="custom-select" name="time" id="timeInput">
                    <option disabled :value="null">Booking times</option>
                    <option v-for="time in this.data.restaurant.information.booking_times" :key="time" :value="time">{{ time }}</option>
                  </select>
                  <!-- Time Select End -->
                  <!-- Number of People Selection Start -->
                  <div id="peopleLabel" class="input-group-prepend">
                    <label class="input-group-text" for="peopleInput">
                      <svg xmlns="http://www.w3.org/2000/svg" width="34" height="34" fill="currentColor" class="bi bi-people-fill" viewBox="0 0 16 16">
                        <path d="M7 14s-1 0-1-1 1-4 5-4 5 3 5 4-1 1-1 1H7zm4-6a3 3 0 1 0 0-6 3 3 0 0 0 0 6z"/>
                        <path fill-rule="evenodd" d="M5.216 14A2.238 2.238 0 0 1 5 13c0-1.355.68-2.75 1.936-3.72A6.325 6.325 0 0 0 5 9c-4 0-5 3-5 4s1 1 1 1h4.216z"/>
                        <path d="M4.5 8a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5z"/>
                      </svg>
                    </label>
                  </div>
                  <select v-model="pax.picker" class="custom-select" name="pax" id="peopleInput">
                    <option v-for="pax in 12" :key="pax" :value="pax">{{ pax }}</option>
                  </select>
                  <!-- Number of People Selection End -->
                  <!-- Booking Button Start -->
                  <div class="input-group-append" id="bookingBtnContainer">
                    <button @click="search" class="btn btn-light" type="button" id="bookingBtn">Check Availability</button>
                  </div>
                  <!-- Booking Button End -->
                  <div v-if="page.showInvalid.searchBtn" id="invalidNote" class="invalid-entry">Please select a booking date and time.</div>
                </div>
                <!-- END OF SEARCH BAR -->
              </div>
            </div>
            <!-- END MIDDLE ROW -->

          <!-- CONTACT US -->
          <ContactForm />

          <!-- FOOTER CONTENT -->
          <div>
            <Footer />
          </div>
          </div>
      </div>
    </div>
  </template>
</template>

<script>
import NavBar from "./NavBar"
import MainHeader from "./MainHeader"
import Carousel from "./Carousel"
import ContactForm from "./ContactForm"
import ModalWindow from "./ModalWindow";
import Footer from "./Footer"
import HourglassIcon from "./HourglassIcon";
import Notification from "./Notification";

export default {
  name: "RestaurantPage",
  components: {
    Notification,
    HourglassIcon,
    ModalWindow,
    NavBar,
    MainHeader,
    Carousel,
    ContactForm,
    Footer
  },
   data() {
     return {
       page: {
         loading: true,
         showConfirmation: false,
         showResponse: false,
         showHourglass: false,
         showLoading: false,
         showInvalid: {
           searchBtn: false,
           submitBtn: false
         },
       },
       invalid_note: null,
       data: {
         restaurant: null
       },
       confirmation_window: {
         title: "Confirm your booking details",
         body: "Finalise your booking by entering your details below."
       },
       response_window: {
         title: null,
         body: null
       },
       date: {
         default: new Date((new Date).getTime() + 86400000).toISOString().slice(0, 10),
         max: new Date(Date.now() + 12096e5).toISOString().slice(0, 10),
         picker: null
       },
       time: {
         picker: null
       },
       pax: {
         picker: 1
       },
       person: {
         name: null,
         mobile: null,
         notes: ""
       }
     }
  },
  props: {
    restaurant_id: {
      type: String
    },
    information_title: {
      type: String
    },
    information_body: {
      type: String
    }
  },
  mounted() {
    fetch('http://localhost:3000/restaurants/' + this.restaurant_id)
        .then(async data => {
          this.data.restaurant = await data.json();
          this.page.loading = false;
        })
        .catch(err => {
          console.log(err)
          this.page.loading = true;
        })
  },
  methods: {
    search() {
      if (this.time.picker === null || this.date.picker === null) {
        this.page.showInvalid.searchBtn = true
      } else {
        if (this.page.showInvalid.searchBtn === true) {
          this.page.showInvalid.searchBtn = false
        }
        this.page.showConfirmation = !this.page.showConfirmation
      }
    },
    async submit() {
      let validation = true;
      this.page.showInvalid.confirmEditBtn = false;

      if (this.person.name === null || this.person.mobile === null) {
        this.invalid_note = "Guest name or mobile cannot be empty";
        this.page.showInvalid.submitBtn = true;
        validation = false;
      }

      else if (!this.person.name.match(/^[a-zA-Z ]+$/)) {
        this.invalid_note = "The guest name cannot contain invalid characters.";
        this.page.showInvalid.submitBtn = true;
        validation = false;
      }

      else if (this.person.name.length < 2) {
        this.invalid_note = "The guest name must be at least two characters.";
        this.page.showInvalid.submitBtn = true;
        validation = false;
      }

      else if (this.person.mobile.slice(0,2) !== "04" || this.person.mobile.length < 10) {
        this.invalid_note = "The mobile number must be a valid 10-digit Australian mobile number.";
        this.page.showInvalid.submitBtn = true;
        validation = false;
      }

      else if (this.person.notes.length > 100) {
        this.invalid_note = "The character limit is 100.";
        this.page.showInvalid.submitBtn = true;
        validation = false;
      }

      if (validation === true) {
        await this.$store.dispatch("getSSE");

        let data = {
          ["restaurant"]: {
            ["id"]: this.restaurant_id,
            ["date"]: this.date.picker,
            ["time"]: this.time.picker,
            ["pax"]: this.pax.picker
          },
          ["person"]: {
            ["name"]: this.person.name,
            ["mobile"]: this.person.mobile,
            ["notes"]: this.person.notes
          }
        }

        await fetch("http://localhost:3000/bookings/", {
          method: "POST",
          mode: "cors",
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify(data)
        })
          .then(async res => {
            this.page.showConfirmation = !this.page.showConfirmation;
            this.page.showHourglass = true;

            let resJson = await res.json();

            if (!res.ok) {
              this.response_window.title = "Booking Request Error";
              this.response_window.body = resJson.errors[0].msg;
            } else {
              this.response_window.title = "Booking Request Successfully Submitted"
              this.response_window.body = resJson.messages[0].msg;
            }

            setTimeout(() => {
              this.page.showHourglass = false;
              this.page.showResponse = !this.page.showResponse;
            }, 2000);
          })
          .catch(err => console.log(err))
      }
    }
  }
}
</script>

<style scoped>
svg {
  color: #886565;
}

#restaurantInfo {
  margin: 2rem 0;
  border: none;
}

#restaurantHeader {
  font-family: Georgia, serif;
  background-color: transparent;
  color: #6e5151;
}

#bookingBtn {
  border-color: #d0d0d0;
  height: 3rem;
}

#searchPropertiesBar {
  max-width: 50rem;
  margin: 4rem auto 0 auto;
}

#calendarInput {
  color: #6d6d6d;
  border-color: #c6c6c6;
  min-width: 8rem;
}

#timeInput, #peopleInput  {
  color: #6d6d6d;
  border-color: #c6c6c6;
}

#confirmationForm {
  color: #926c6c;
}

#confirmationForm > label {
  margin-top: 1rem;
}

#submitContainer {
  padding: 0 0 0 31rem;
}

.btn {
  color: #584141;
  background-color: #f3f3f3;
  border-color: #c6c6c6;
}

.btn-light:hover {
  background-color: #a97c7c;
  color: #f6ede3;
}

.card-text.card-info {
  margin-left: 2rem;
  color: #8c7e73;
}

.input-group-text {
  background-color: #E7DBCE;
}

.custom-select {
  border: 0.1em solid #c6c6c6;
}

.invalid-entry {
  display: block;
  color: #d02b2b;
  font-size: small;
  margin: 1rem 0;
}

@media (max-width: 600px) {
  svg {
    height: 1.5rem;
  }

  #calendarInput {
    width: 2rem;
  }

  #timeInput {
    width: 5rem;
  }

  #bookingBtnContainer {
    margin: 2rem auto 0 auto;
  }
}
</style>